// Последнее обновление 2017-05-31 by Phisik
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Здесь всяческий вывод на экран
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <LiquidCrystal.h>
#include <OneWire.h>
#include <EEPROM.h> 

#include "configuration.h"
#include "declarations.h"

char flNumStrPrint=0;

void my_lcdprint(char *s)
{ 
  char i;
  char len;
  len=strlen(lcd_buffer);  
  for(i=len;i<16;i++) s[i]=' ';
  s[16]=0;

  if (IspReg==111 && s[9]=='R' && flNumStrPrint==0) s[9]='N';

  lcd.print(s);  

// MQTT code by max506 & limon
#if defined(USE_MQTT_BROKER) && (USE_MQTT_BROKER==1)

  if (flNumStrPrint==0) {
    
    sprintf(lcd_mqtt_buf1, GePMEM(buf_pmem,fmt_lcd1), s);
   
    // Убрать завершающие пробелы
    for(i=strlen(lcd_mqtt_buf1)-1; ;i--) {
      if (lcd_mqtt_buf1[i]==' ') lcd_mqtt_buf1[i]='\0';
      else break;
    }
  }
  else if (flNumStrPrint==1) {
 
    sprintf(lcd_mqtt_buf2, GePMEM(buf_pmem,fmt_lcd2), s);
   
    // Убрать завершающие пробелы
    for(i=strlen(lcd_mqtt_buf2)-1; ;i--) {
      if (lcd_mqtt_buf2[i]==' ') lcd_mqtt_buf2[i]='\0';
      else break;
    }    
 }

#endif // USE_MQTT_BROKER


#if USE_GSM_WIFI==1

      // Если состояние отправки - надо отправить экран, тогда отправляем еще и на сервер.
      if (flGPRSState==20 || flGPRSState==164)
      {
        if (flNumStrPrint==0)
        {   // Первой строчкой отправляем id устройства и первую строку экрана
          sprintf(my_gprs_buffer,"%s;%s",idDevice,s); //запись в буфер текста и значений температуры в подготовленном
          Serial2.print(my_gprs_buffer);
    #ifdef TESTGSM
          Serial.println("SendDTA1:");
          Serial.println(my_gprs_buffer);
    #endif
    
        }
        else
        {   // Второй строчкой отправляем нужную часть экрана, состояние контроллера и последнюю выполненную команду. 
          sprintf(my_gprs_buffer,"%s;%3i;%3i;%c#",s,(int) IspReg,(int) StateMachine,cmdGPRSIsp);
          Serial2.println(my_gprs_buffer);
    #ifdef TESTGSM
          Serial.println("SendDTA2:");
          Serial.println(my_gprs_buffer);
    #endif
          flGPRSState++; // Переводим контроллер в состояние отправлено.
          //timeWaitGPRS=20;
          timeWaitGPRS=2; // Две секунды достаточно для отправки
        }
      }
    
      flNumStrPrint++;
#endif


#ifdef TESTMEM
  Serial.println("\n[memCheck_print]");
  Serial.println(freeRam());
#endif
}

unsigned char hour,minute,second;
int V1,V2,V3;

void formTRZGDistill()
{
  if (TempDeflBegDistil>0) sprintf(lcd_buffer,"tD=%3i/%3i %4iW",temps[TEMP_DEFL],TempDeflBegDistil,Power);
  else  sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],-TempDeflBegDistil,Power);

}

void formTSAErr()
{
  sprintf(lcd_buffer,"%02u:%02u:%02u TSA!",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
  //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
  my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
  sprintf(lcd_buffer,"tT=%3i/%3i",temps[TEMP_TSA],MAX_TEMP_TSA); //запись в буфер текста и значений температуры в подготовленном
}

void DisplayRectif()
{
  if (DispPage==0) 
  {
    switch (StateMachine)
    { 
    case 0: //Не запущено
    case 1: //Не запущено
      sprintf(lcd_buffer,"%02u:%02u:%02u Rect",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном

      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      //sprintf(lcd_buffer,"tK=%3i P=%4i",temps[TEMP_KUB],Power); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 2: //Разгон
      sprintf(lcd_buffer,"%02u:%02u:%02u R RZG",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      if (tEndRectRazgon>0) sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
      else sprintf(lcd_buffer,"tN=%3i/%3i %4iW",temps[TEMP_RK20],-tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 3: //Стабилицация колонны
      sprintf(lcd_buffer,"%02u:%02u:%02u R NSB",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tN=%3i(%3i)%4iW",temps[TEMP_RK20],(IspReg==111 ?(int)(SecOstatok):(int)(Seconds-SecTempPrev)),PowerRect); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 4: //Отбор голов
      if (IspReg!=118)
      {
        sprintf(lcd_buffer,"%02u:%02u:%02u R GLV",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
        //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    

        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        if (UrovenProvodimostSR==0)
          sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],tEndRectOtbGlv,PowerRect); //запись в буфер текста и значений температуры в подготовленном
        else
          if (UrovenProvodimostSR>0)
          {
            if  (UrovenProvodimostSR==2) sprintf(lcd_buffer,"Pr=%3i/%3i %4iW",U_GLV,UROVEN_ALARM,PowerRect); //запись в буфер текста и значений температуры в подготовленном
            else sprintf(lcd_buffer,"Pr=%3i/%3i %4iW",U_GLV,UrovenProvodimostSR,PowerRect); //запись в буфер текста и значений температуры в подготовленном
          }
          else
            sprintf(lcd_buffer,"Tm=%3i/%3i %4iW",(int) SecOstatok,-UrovenProvodimostSR,PowerRect); //запись в буфер текста и значений температуры в подготовленном
      }
      else
      {

        sprintf(lcd_buffer,"%02u:%02u:%02u RF GLV",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
        if (TekFraction<CountFractionRect) V2=TempFractionRect[TekFraction];
        if (V2>=0) sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],V2,UstPower);
        else sprintf(lcd_buffer,"t=%5imin %4iW",(int) SecOstatok,UstPower);

      }  
      break;
    case 5: //Стоп, ожидание возврата температуры
      sprintf(lcd_buffer,"%02u:%02u:%02u R Stop",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tN=%3i/%3i %2i%%",temps[TEMP_RK20],tStabSR,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 6: //Ректификация
      sprintf(lcd_buffer,"%02u:%02u:%02u RSt %2i%%",hour,minute,second,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tN=%3i/%3i/d%2i",temps[TEMP_RK20],tStabSR+tDeltaRect,tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 7: //Отбор хвостов
      sprintf(lcd_buffer,"%02u:%02u:%02u R Hvost",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i/%3i",temps[TEMP_KUB],IspReg!=118 ? tEndRect:TekTemp); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 8: //Отбор ожидание 3 минут
      sprintf(lcd_buffer,"%02u:%02u:%02u R Wait",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i/%3i",temps[TEMP_KUB],IspReg!=118 ? tEndRect : TekTemp); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 9: //Ожидание датчика уровня
      sprintf(lcd_buffer,"%02u:%02u:%02u R Wait",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"by Urov=%3i/%3i",U_UROVEN,UROVEN_ALARM); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 100: //Окончание
      sprintf(lcd_buffer,"%02u:%02u:%02u Rec End",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i/%3i End",temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 101: //Температура в ТСА превысила предельную
      formTSAErr();
      break;
    case 102: //Давление
      sprintf(lcd_buffer,"%02u:%02u:%02u Pres",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
      sprintf(lcd_buffer,"MPX5010=%3i/%3i",U_MPX5010,AlarmMPX5010); //запись в буфер текста и значений температуры в подготовленном
      break;

    }
  }
  else
  {
    sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    if (StateMachine!=5) 
    {   
      if (IspReg!=118)  sprintf(lcd_buffer,"%3immV=%4u,%4u",U_MPX5010,U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
      else 
        if (TekFraction<CountFractionRect)
      {
        if (TempFractionRect[TekFraction]>0) 
          sprintf(lcd_buffer,"%3imm t=%3i F%1i/%1i",U_MPX5010,TempFractionRect[TekFraction],(int) TekFraction+1,(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
        else
          sprintf(lcd_buffer,"%3imm %4im F%1i/%1i",U_MPX5010,(int) SecOstatok,(int) TekFraction+1,(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
      }
      else
        sprintf(lcd_buffer,"%3immV=%4u F%1i/%1i",U_MPX5010,U_UROVEN,(int) TekFraction+1,(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
    }
    else sprintf(lcd_buffer,"%3imm reSt=%5i",U_MPX5010,time1); //запись в буфер текста и значений температуры в подготовленном
  }

}

void DisplayDistDefl()
{
  if (DispPage==0) 
  {
    switch (StateMachine)
    { 
    case 0: //Не запущено
    case 1: //Нагрев до температуры 50 градусов
      sprintf(lcd_buffer,"%02u:%02u:%02u DD",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      formTRZGDistill();
      break;
    case 2: //Ожидание закипания (прогреется дефлегматор)
      sprintf(lcd_buffer,"%02u:%02u:%02u DD Rzg",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tD=%3i/%3i %4iW",temps[TEMP_DEFL],TempDeflBegDistil,UstPower); 
      break;
    case 3: //Ожидание закипания (прогреется куб дефлегматор)
      sprintf(lcd_buffer,"%02u:%02u:%02u DD Rzg",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],TempDeflBegDistil,UstPower); 
      break;
    case 4: //Работа без дефлегматора
      sprintf(lcd_buffer,"%02u:%02u:%02u DD BezD",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tD=%3i/%3i %4iW",temps[TEMP_DEFL],TempDefl,UstPower); 
      break;
    case 5: //Работа с 50% дефлегмацией
      sprintf(lcd_buffer,"%02u:%02u:%02u DD 50%%",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tD=%3i/%3i %4iW",temps[TEMP_DEFL],TempDefl-DeltaDefl,UstPower); 
      break;
    case 6: //Работа с 100% дефлегмацией
      sprintf(lcd_buffer,"%02u:%02u:%02u DD 100%%",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tD=%3i/%3i %4iW",temps[TEMP_DEFL],TempDefl-DeltaDefl,UstPower); 
      break;
    case 7: //Ожидание для охлаждения
      sprintf(lcd_buffer,"%02u:%02u:%02u DD Wait",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i Wait=%4i",temps[TEMP_KUB],SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 100: //Окончание
      sprintf(lcd_buffer,"%02u:%02u:%02u DD end",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i end",temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
      break;
    }
  }
  else
  {
    sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,"V%4u,%4u-%4iW",U_VODA,U_UROVEN,deltaPower); //запись в буфер текста и значений температуры в подготовленном
  }

}
/*
void DisplaySimpleGLV()
 {
 
 if (DispPage==0)
 {
 switch (StateMachine)
 { 
 case 0: //Не запущено
 case 1: //Нагрев до температуры 50 градусов
 sprintf(lcd_buffer,"%02u:%02u:%02u sGl Not",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 formTRZGDistill(); 
 break;
 case 2: //Ожидание закипания (прогреется дефлегматор)
 sprintf(lcd_buffer,"%02u:%02u:%02u sGl Rzg",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 formTRZGDistill(); 
 break;
 case 3: //Ожидание закипания (прогреется куб дефлегматор)
 sprintf(lcd_buffer,"%02u:%02u:%02u sGl Rzg",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],TempDeflBegDistil,Power); 
 break;
 case 4: //Отбор голов
 sprintf(lcd_buffer,"%02u:%02u:%02u sGl Otb",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],Temp3P,PowerGlvDistil); 
 break;
 case 5: //Ожидание 60 секунд для охлаждения
 sprintf(lcd_buffer,"%02u:%02u:%02u sOtbGlv",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"tK=%3i Wait=%4i",temps[TEMP_KUB],SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 100: //Окончание
 sprintf(lcd_buffer,"%02u:%02u:%02u sOtbGlv",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"tK=%3i end",temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 101: //Температура в ТСА превысила предельную
 formTSAErr();
 break;
 }
 }
 else
 {
 sprintf(lcd_buffer,"D2 T=%3u,%3u,%3u",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
 my_lcdprint(lcd_buffer);
 sprintf(lcd_buffer,"V=%4u,%4u,%4u",U_VODA,U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
 }
 }*/

void DisplaySimpleDistill()
{
  if (DispPage==0) 
  {
    if (IspReg==104) 
    { 
      V1=1;
      V2=Temp1P;   
    }
    if (IspReg==106) 
    { 
      V1=2;
      V2=Temp2P;   
    }
    if (IspReg==107   || IspReg==105 ) 
    { 
      V1=3;
      V2=Temp3P;   
    }

    if (IspReg!=105)  sprintf(lcd_buffer,"%02u:%02u:%02u %1u-Otbor",hour,minute,second,V1); //запись в буфер текста и значений температуры в подготовленном
    else  sprintf(lcd_buffer,"%02u:%02u:%02u sGl",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном

    switch (StateMachine)
    { 
    case 0: //Не запущено
    case 1: //Нагрев до температуры 50 градусов
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 2: //Ожидание закипания (прогреется дефлегматор)
      if (IspReg!=105)  sprintf(lcd_buffer,"%02u:%02u:%02u %1u-O Rzg",hour,minute,second,V1); //запись в буфер текста и значений температуры в подготовленном
      else sprintf(lcd_buffer,"%02u:%02u:%02u sGl Rzg",hour,minute,second,V1); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      formTRZGDistill();
      break;
    case 3: //Дистилляция
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],V2,UstPower); 
      break;
    case 4: //Ожидание 60 секунд для охлаждения
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i Wait=%4i",temps[TEMP_KUB],SecondsEnd); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 100: //Окончание
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i end",temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
      break;                        
    case 101: //Температура в ТСА превысила предельную
      formTSAErr();
      break;
    }
  }
  else
  {
    sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,"V%4u,%4u %4uW",U_VODA,U_UROVEN,UstPower); //запись в буфер текста и значений температуры в подготовленном
  }

}
void DisplayFracionDistill()
{
  if (DispPage==0) 
  {
    sprintf(lcd_buffer,"%02u:%02u:%02u DsF %1i/%1i",hour,minute,second,(int) (TekFraction<CountFractionDist) ? TekFraction+1: CountFractionDist,(int) CountFractionDist); //запись в буфер текста и значений температуры в подготовленном

    switch (StateMachine)
    { 
    case 0: //Не запущено
    case 1: //Нагрев до температуры 50 градусов
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      break;
    case 2: //Ожидание закипания (прогреется дефлегматор)
      sprintf(lcd_buffer,"%02u:%02u:%02u DsF Rzg",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      formTRZGDistill();
      break;
    case 3: //Дистилляция
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

      if (TekFraction<CountFractionDist) V2=TempFractionDist[TekFraction];
      if (V2>=0) sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],V2,UstPower);
      else sprintf(lcd_buffer,"t=%5imin %4iW",(int) SecOstatok,UstPower);

      break;
    case 4: //Ожидание 60 секунд для охлаждения
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i Wait=%4i",temps[TEMP_KUB],time3); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 100: //Окончание
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i end",temps[TEMP_KUB]); //запись в буфер текста и значений температуры в подготовленном
      break;                        
    case 101: //Температура в ТСА превысила предельную
      formTSAErr();
      break;
    }
  }
  else
  {
    sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,"V%4u,%4u %4uW",U_VODA,U_UROVEN,UstPower); //запись в буфер текста и значений температуры в подготовленном
  }

}
void DisplayRazvar()
{
  if (DispPage==0) 
  {
    if (IspReg==114)  sprintf(lcd_buffer,"%02u:%02u:%02u HLD Ztr",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
    else sprintf(lcd_buffer,"%02u:%02u:%02u Razvar",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    switch (StateMachine)
    { 
    case 0: //Не запущено
      //            case 1: //Нагрев до температуры 50 градусов
      //              sprintf(lcd_buffer,"t=%3i P=%4i",temps[TEMP_RAZVAR],UstPower); //запись в буфер текста и значений температуры в подготовленном
      //              break;
    case 1: //Нагрев до температуры 50 градусов
      sprintf(lcd_buffer,"t=%3i/%3i %4iW",temps[TEMP_RAZVAR],(int)TempZSP*10,UstPower); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 2: //Поддержание температуры 50 градусов, пока не произойдет ручной переход к следующему этапу.
      sprintf(lcd_buffer,"t=%3i ZASYP & Dn",temps[TEMP_RAZVAR]); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 3: //Нагрев до температуры 64 градуса
      sprintf(lcd_buffer,"t=%3i/%3i %4iW",temps[TEMP_RAZVAR],(int)TempZSPSld*10,UstPower); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 4: //Ожидание 15 минут, поддержка температуры
      sprintf(lcd_buffer,"t=%3i %4iW %4i",temps[TEMP_RAZVAR],UstPower,time2); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 5: //Нагрев до кипения
      if (ds1820_devices<2)
        sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_RAZVAR],TempKipenZator,UstPower); //запись в буфер текста и значений температуры в подготовленном
      else
        sprintf(lcd_buffer,"tD=%3i/%3i %4iW",temps[TEMP_DEFL],TempKipenZator,UstPower); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 6: //Варка
      sprintf(lcd_buffer,"t=%3i %4iW %4i",temps[TEMP_RAZVAR],PowerRazvZerno,time2); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 7: //Охлаждение до температыры осахаривания
      sprintf(lcd_buffer,"tK=%3i/%3i HLD-1",temps[TEMP_RAZVAR],(int)TempZSPSld*10); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 8: //Поддержание температуры 50 градусов, пока не произойдет ручной переход к следующему этапу.
      sprintf(lcd_buffer,"t=%3i SOLOD & Dn",temps[TEMP_RAZVAR]); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 9: //Мешаем 10 минут
      sprintf(lcd_buffer,"tK=%3i MIX %4i",temps[TEMP_RAZVAR],time2); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 10: //Осахаривание
      sprintf(lcd_buffer,"tK=%3i OSH %4i",temps[TEMP_RAZVAR],time2); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 11: //Охлаждение до температуры первичного внесения дрожжей осахаривания
      sprintf(lcd_buffer,"tK=%3i/400 HLD-2",temps[TEMP_RAZVAR]); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 12: //Охлаждение до температыры осахаривания
      sprintf(lcd_buffer,"tK=%3i/%3i HLD-3",temps[TEMP_RAZVAR],(int)TempHLDZatorBrog1*10); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 13: //Поддержка брожения, ничего не делаем, только мешаем периодически
      sprintf(lcd_buffer,"tK=%3i/%3i BROG",temps[TEMP_RAZVAR],(int)TempHLDZatorBrog1*10); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 14: //Поддержка брожения - охлаждение
      sprintf(lcd_buffer,"tK=%3i/%3i BR-H",temps[TEMP_RAZVAR],(int)TempHLDZatorBrog1*10-5); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 100: //Окончание
      sprintf(lcd_buffer,"t=%3i end",temps[TEMP_RAZVAR]); //запись в буфер текста и значений температуры в подготовленном
      break;
    }
  }
  else
  {
    sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,"OSH=%3u NPG=%4u",(int)TempZSPSld*10,U_NPG); //запись в буфер текста и значений температуры в подготовленном
  }

}
/*
void DisplayNDRF()
 {
 if (DispPage==0) 
 {
 switch (StateMachine)
 { 
 case 0: //Не запущено
 case 1: //Не запущено
 sprintf(lcd_buffer,"%02u:%02u:%02u NDRF",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"tK=%3i P=%4i",temps[TEMP_KUB],Power); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 2: //Разгон
 sprintf(lcd_buffer,"%02u:%02u:%02u ND RZG",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 if (tEndRectRazgon>0) sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
 else sprintf(lcd_buffer,"tN=%3i/%3i %4iW",temps[TEMP_RK20],-tEndRectRazgon,UstPower); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 3: //Стабилицация колонны
 sprintf(lcd_buffer,"%02u:%02u:%02u ND NSB",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"t=%3i(%4i)%4iW",temps[TEMP_RK20],(int)(SecOstatok),PowerRect); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 4: //Отбор голов
 sprintf(lcd_buffer,"%02u:%02u:%02u ND GLV",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 if (UrovenProvodimostSR==0)
 sprintf(lcd_buffer,"tK=%3i/%3i %4iW",temps[TEMP_KUB],tEndRectOtbGlv,PowerRect); //запись в буфер текста и значений температуры в подготовленном
 else
 if (UrovenProvodimostSR>0)
 sprintf(lcd_buffer,"Pr=%3i/%3i %4iW",U_GLV,UrovenProvodimostSR,PowerRect); //запись в буфер текста и значений температуры в подготовленном
 else
 sprintf(lcd_buffer,"Tm=%3i/%3i %4iW",(int) SecOstatok,-UrovenProvodimostSR,PowerRect); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 5: //Стоп, ожидание возврата температуры
 sprintf(lcd_buffer,"%02u:%02u:%02u ND Stop",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"tN=%3i/%3i %2i%%",temps[TEMP_RK20],tStabSR,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 6: //Ректификация
 sprintf(lcd_buffer,"%02u:%02u:%02u NDst %2i%%",hour,minute,second,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
 //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"tN=%3i/%3i/d%2i",temps[TEMP_RK20],tStabSR+tDeltaRect,tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 7: //Отбор хвостов
 sprintf(lcd_buffer,"%02u:%02u:%02u ND Hvst",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"tK=%3i/%3i",temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 8: //Отбор ожидание 3 минут
 sprintf(lcd_buffer,"%02u:%02u:%02u ND Wait",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"tK=%3i/%3i",temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 9: //Ожидание датчика уровня
 sprintf(lcd_buffer,"%02u:%02u:%02u R Wait",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"by Urov=%3i/%3i",U_UROVEN,UROVEN_ALARM); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 100: //Окончание
 sprintf(lcd_buffer,"%02u:%02u:%02u ND End",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf(lcd_buffer,"tK=%3i/%3i",temps[TEMP_KUB],tEndRect); //запись в буфер текста и значений температуры в подготовленном
 break;
 case 101: //Температура в ТСА превысила предельную
 formTSAErr();
 break;
 case 102: //Давление
 sprintf(lcd_buffer,"%02u:%02u:%02u Pres",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
 //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
 my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
 sprintf(lcd_buffer,"MPX5010=%3i/%3i",U_MPX5010,AlarmMPX5010); //запись в буфер текста и значений температуры в подготовленном
 break;
 
 }
 }
 else
 {
 sprintf(lcd_buffer,"D2 T=%3u,%3u,%3u",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
 my_lcdprint(lcd_buffer);
 sprintf(lcd_buffer,"%3immV=%4u,%4u",U_MPX5010,U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
 }
 
 }*/

void DisplayNBK()
{
  if (DispPage==0) 
  {
    switch (StateMachine)
    { 
    case 0: //Не запущено
      sprintf(lcd_buffer,"%02u:%02u:%02u NBK",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tK=%3i,%3imm",temps[TEMP_KUB],U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 1: //Ожидание закипания (прогреется дефлегматор)
    case 2: //Ожидание закипания (прогреется дефлегматор)
      sprintf(lcd_buffer,"%02u:%02u:%02u NBK Rzg",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      formTRZGDistill();
      break;
    case 3: //Ожидание запуска
      sprintf(lcd_buffer,"%02u:%02u:%02u NBK Beg",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"UP to Beg %3imm",U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 4: //Запущено
    case 6: //Запущено, подача браги остановлена
      sprintf(lcd_buffer,"%02u:%02u:%02u NBK Wrk",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"Sp=%4i,%3imm",(int) SpeedNBK,U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 5: //Превышение температуры вверху
      sprintf(lcd_buffer,"%02u:%02u:%02u NBK tmp",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"tD=%3i/970,s%4i",temps[TEMP_DEFL],time2); //запись в буфер текста и значений температуры в подготовленном
      break;
    case 100: //Окончание
      sprintf(lcd_buffer,"%02u:%02u:%02u NBK End",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
      //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"Sp=%4i,%3imm",(int) SpeedNBK,U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
      break;
    }
  }
  else
  {
    sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,"%4uW,%3imm %3i",UstPower,U_MPX5010,MaxPressByPeriod); //запись в буфер текста и значений температуры в подготовленном
  }
}
void DisplayTestKLP()
{
  if (DispPage==0) 
  {
    sprintf(lcd_buffer,"%02u:%02u:%02u tst Dev",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
    //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"St=%3i CHIM=%3i",StateMachine,ProcChimSR); //запись в буфер текста и значений температуры в подготовленном
  }
  else
  {
    sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,"%3u,%3u Gas=%4u",temps[3],temps[4],U_GAS); //запись в буфер текста и значений температуры в подготовленном
  }

}

void DisplayExtContol()
{
  if (DispPage==0) 
  {
    sprintf(lcd_buffer,"%02u:%02u:%02u ExtCtrl",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
    //sprintf(lcd_buffer,"%u%u%u%u  %u%u%u%u",PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3); //запись в буфер текста и значений температуры в подготовленном                    
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"T=%3u,%3u %4iW",temps[0],temps[1],UstPower); //запись в буфер текста и значений температуры в подготовленном
  }
  else
  {
    sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,"%3u,%3u Gas=%4u",temps[3],temps[4],U_GAS); //запись в буфер текста и значений температуры в подготовленном
  }

}

void DisplayBeer()
{
  if (DispPage==0) 
  {
    sprintf(lcd_buffer,"%02u:%02u:%02u beer",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    if (StateMachine==2)   sprintf(lcd_buffer,"T=%3i/%3i P%2i/%2i",temps[TEMP_TERMOSTAT],(int) tempP[KlTek]*10,(int) KlTek,(int) CntPause); //запись в буфер текста и значений температуры в подготовленном
    if (StateMachine==3)  
    {  
      if (timeP[KlTek]!=0)
        sprintf(lcd_buffer,"Ts=%5i P=%2i/%2i",time2,(int) KlTek,(int) CntPause); //запись в буфер текста и значений температуры в подготовленном
      else
        sprintf(lcd_buffer,"Press UP to%2i/%2i",(int) KlTek+1,(int) CntPause); //запись в буфер текста и значений температуры в подготовленном

    }             
    if (StateMachine==100)   sprintf(lcd_buffer,"end"); //запись в буфер текста и значений температуры в подготовленном
  }
  else
  {
    sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,"mix=%5i %4iW",time1,UstPower); //запись в буфер текста и значений температуры в подготовленном
  }
}

void DisplayData()
{
  int tic1;
  static int PrevState=0;
  static char flDspDop=0; // Флаг для отображения информации (через раз)
  char j; // Временная переменная для цикла
  flNumStrPrint=0;
  flDspDop=!flDspDop;

  hour=Seconds / 3600;
  tic1=Seconds % 3600;
  minute=tic1 / 60;
  second=tic1 % 60;   

  if (FlState==0) 
    lcd.setCursor(0, 0);
  else 
  { 
    // Если предыдущее состояние было 0, то даем задерку в 1/10 секунды, чтобы не слишком часто обновлялся
    // дисплей.
    if (PrevState==0)  delay(100);

    if (FlState!=PrevState)
    {
      lcd.clear();  //очистка дисплея   
      PrevState=FlState;
    }

    lcd.setCursor(0, 0);
  }

#ifdef TESTMEM
  Serial.println("\n[memCheck_displ]");
  Serial.println(freeRam());
#endif

  switch (FlState)
  {
  case 0:

    if (DispPage<2) // Первые две страницы отображаются по-разному, остальные всегда одни и те же
    {
      switch (IspReg)
      {
      case 101: // Displaying
        //sprintf(lcd_buffer,"S=%5u TT=%5u",Seconds,MaxTimeTimer); //запись в буфер текста и значений температуры в подготовленном

        //  Выводим сетевое напряжение по тому же принципу, что и работают дешевые вольтметры, то есть максимальное количество вольт в сети умножаем на 0,707
        //  это напряжение нужно для калибровки нашего измерителя

        if (DispPage==0) 
        {
          sprintf(lcd_buffer,"%02u:%02u:%02u DSP 1/2",hour,minute,second); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
          sprintf(lcd_buffer,"Zr=%4u U=%3i",TicZero,MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
        }

        if (DispPage==1) 
        {
          sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
          sprintf(lcd_buffer,"V=%4u,%4u,%4u",U_VODA,U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
        }
        //          lcd.setCursor(0, 1);
        //          my_lcdprint(lcd_buffer);                      

        break;
      case 102: // Термостат         
        if (DispPage==0) 
        {
          sprintf(lcd_buffer,"%02u:%02u:%02u TermSt",hour,minute,second,Delta); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
          sprintf(lcd_buffer,"t=%3i/%3i(%2i) %1i",temps[TEMP_TERMOSTAT],TempTerm,Delta,StateMachine); //запись в буфер текста и значений температуры в подготовленном
        }
        else
        {
          sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
          sprintf(lcd_buffer,"%3u,%3u P=%3imm",temps[3],temps[4],U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
        }
        break;
      case 115: // Таймер
        if (DispPage==0) 
        {
          sprintf(lcd_buffer,"%02u:%02u:%02u Timer",hour,minute,second,Delta); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
          minute=Seconds / 60;
          sprintf(lcd_buffer,"tm=%3i/%3i %4iW",minute,timerMinute,UstPower); //запись в буфер текста и значений температуры в подготовленном
        }
        else
        {
          sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
          sprintf(lcd_buffer,"%3u,%3u %4iW",temps[3],temps[4],PowerMinute); //запись в буфер текста и значений температуры в подготовленном
        }
        break;
      case 116: // Пивоварня - клон браумастера
        DisplayBeer();
        break;
      case 103: // Регулятор мощности
        if (DispPage==0) 
        {
#ifndef USE_SLAVE
          sprintf(lcd_buffer,"%02u:%02u:%02u RMU=%3u",hour,minute,second,MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
#if SIMPLED_VERSION==20
          sprintf(lcd_buffer,"P=%3u/%3u%% c%3u",UstPowerReg/10,Power/10,indexOut); //запись в буфер текста и значений температуры в подготовленном
#else
          sprintf(lcd_buffer,"P=%4u/%4u c%3u",UstPowerReg,Power,indexOut); //запись в буфер текста и значений температуры в подготовленном
#endif
#ifdef TEST
          if (NUM_PHASE>1) sprintf(lcd_buffer,"%s",my_rx_buffer); //запись в буфер текста и значений температуры в подготовленном
#endif
#else
          sprintf(lcd_buffer,"%02u:%02u:%02u RMU=%3u",hour,minute,second,MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
          sprintf(lcd_buffer,"PSlv=%4u/%4u",UstPower,Power); //запись в буфер текста и значений температуры в подготовленном
#endif
        }
        else
        {
          sprintf(lcd_buffer,"D2 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
          my_lcdprint(lcd_buffer);
#ifndef USE_SLAVE
          sprintf(lcd_buffer,"Up to auto=%4uW",Power); //запись в буфер текста и значений температуры в подготовленном
#else
          if (flAutoDetectPowerTEN)
            sprintf(lcd_buffer,"Up to auto=%4uW",Power); //запись в буфер текста и значений температуры в подготовленном
          else
            sprintf(lcd_buffer,"SlaveOn (Up)=%1i",(int) SlaveON); //запись в буфер текста и значений температуры в подготовленном
#endif
        }
        break;
      case 105: // Отбор голов33
        //          DisplaySimpleGLV();
        //          break;
      case 104: // Перевый (недробный) отбор
      case 106: // Второй дробный отбор
      case 107: // Третий дробный отбор
        DisplaySimpleDistill();
        break;

      case 117: // Фракционная перегонка
        DisplayFracionDistill();
        break;

      case 108: // Разваривание
      case 113: // Разваривание мучно-солодового затора (без варки).
      case 114: // Разваривание
        DisplayRazvar();
        break;
      case 109: // Ректификация
      case 118: // Ректификация
        DisplayRectif();
        break;
#ifndef TEST
#ifndef DEBUG // Это отображение информации выкусываем, если в режиме теста, потому что не хватает памяти
#ifndef TESTGSM
#ifndef TESTGSM1
      case 110: // Дистилляция с дефлегматором
        DisplayDistDefl();
        break;
      case 111: // НДРФ
        DisplayRectif();
        break;
#endif
#endif
#endif
#endif

      case 112: // NBK
        DisplayNBK();
        break;

      case 130: // Резерв
        DisplayExtContol();
        break;
      case 129: // тест клапанов
        DisplayTestKLP();
        break;
      case 248:
        //          sprintf(lcd_buffer,"LOW LEVEL VOLTS!"); //запись в буфер текста и значений температуры в подготовленном
        //          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        //          sprintf(lcd_buffer,"Umax=%i Sec=%3i",MaxVoltsOut,(int) ErrCountIndex*12); //запись в буфер текста и значений температуры в подготовленном
        break;
      case 249:
        sprintf(lcd_buffer,"NO DETECT ZERO!"); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf(lcd_buffer,"Umax=%i",MaxVoltsOut); //запись в буфер текста и значений температуры в подготовленном
        break;
      case 250:
        sprintf(lcd_buffer,"ALARM VODA !"); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        break;
      case 251:
        sprintf(lcd_buffer,"ERR Ds18b20!"); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf(lcd_buffer,"Num=%i",(int) NumErrDs18); //запись в буфер текста и значений температуры в подготовленном

        break;
      case 252:
        sprintf(lcd_buffer,"ALARM GAS SENS!"); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        break;
      case 253:
        sprintf(lcd_buffer,"NPG OSUHENIE!"); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf(lcd_buffer,"U_NPG=%i CNT=%i",U_NPG, countAlrmNPG); //запись в буфер текста и значений температуры в подготовленном
        break;
      case 254:
        sprintf(lcd_buffer,"NPG PEREPOLN!"); //запись в буфер текста и значений температуры в подготовленном
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
        sprintf(lcd_buffer,"U_NPG=%i CNT=%i",U_NPG, countAlrmNPG); //запись в буфер текста и значений температуры в подготовленном
        break;

      }   
      // Это обычное состояние
      //
      if (StateNPG==1 && DispPage==0) sprintf(lcd_buffer,"Napolnenie NPG.."); //запись в буфер текста и значений температуры в подготовленном

    }
    // Третья страница отображения универсальна, там показываем напряжение, дистанцию и возможное число ошибок
    // расчета среднеквадратичного. 

    if (DispPage==2)
    {
      #if USE_GSM_WIFI==1
          sprintf(lcd_buffer,"D3 %3i,w%3u,i%3i",(int)flGPRSState,(int)timeWaitGPRS,(int)timeGPRS); 
          my_lcdprint(lcd_buffer);
      #else
          my_lcdprint("D3 No GSM Supp.");
      #endif

      sprintf(lcd_buffer,"%4iW,%3uV,%3uA",FactPower,MaxVoltsOut,MaxIOut); //запись в буфер текста и значений температуры в подготовленном
    }
    // На четвертой странице показываем всю температуру и давление
    if (DispPage==3)
    {
      sprintf(lcd_buffer,"D4 T=%3i,%3i,%3i",temps[0],temps[1],temps[2]); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,"%3i,%3i P=%3imm",temps[3],temps[4],U_MPX5010); //запись в буфер текста и значений температуры в подготовленном
    }

    // На пятой странице показываем состояние датчиков уровней
    if (DispPage==4)
    {
      sprintf(lcd_buffer,"D5 VODA=%4u", U_VODA); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,"URV=%4u GL=%4u",U_UROVEN,U_GLV); //запись в буфер текста и значений температуры в подготовленном
    }

    // На шестой странице показываем состояние датчиков уровней
    if (DispPage==5)
    {
      sprintf(lcd_buffer,"D6 GAS=%4u", U_GAS); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,"zPS=%3u,%4uW",(int) zPSOut,UstPwrPH1); //запись в буфер текста и значений температуры в подготовленном
    }

    // На седьмой странице показываем состояние регулятора мощности
    if (DispPage==6)
    {
#if NUM_PHASE==1
      sprintf(lcd_buffer," %4i,%4i,%4iW",UstPwrPH1,UstPwrPH2,UstPwrPH3); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,"D7 %3i,%3i,%3i %%",KtPhase[0],KtPhase[1],KtPhase[2]); //запись в буфер текста и значений температуры в подготовленном
#else
      sprintf(lcd_buffer,"D7 T=%4u,Z=%4u", TimeOpenTriac,TicZero); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,"KLP=%4u,Bz=%3u",TimeOpenKLP,(int)b_value[0]); //запись в буфер текста и значений температуры в подготовленном
#endif
    }

    // На восьмой можно сменить состояние процесса.
    if (DispPage==7)
    {
      sprintf(lcd_buffer,"D8 State Debug"); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,"StateMacine=%i",(int)StateMachine); //запись в буфер текста и значений температуры в подготовленном
    }

    // На девятой состояние ПИД-регулятора
    if (DispPage==8)
    {
      sprintf(lcd_buffer,"D9 N=%4i O=%4i",NewErr,OldErrOut); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,"Dt=%4i It=%4i",Dt,It); //запись в буфер текста и значений температуры в подготовленном
    }
    // На Десятой странице показываем максимальные температуры за процесс температуру и давление
    if (DispPage==9)
    {
      sprintf(lcd_buffer,"D10 MaxT=%3i,%3i",Maxtemps[0],Maxtemps[1]); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,"%3i,%3i,%3i",Maxtemps[2],Maxtemps[3],Maxtemps[4]); //запись в буфер текста и значений температуры в подготовленном
    }
    // На 11  странице показываем параметры расчета ПИД-регулятора
    if (DispPage==10)
    {
      sprintf(lcd_buffer,"D11 N,O=%3i %3i",NewErrTemp,OldErrTempOut); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer);
      sprintf(lcd_buffer,"KId%4i %4i %3i",KtT,ItTemp,DtTemp); //запись в буфер текста и значений температуры в подготовленном
    }

    if (flDspDop && DispDopInfo>0) // Если отображаем дополнительную информацию, тогда проверяем ее статус
    {

      if (BeepStateProcess>1) 
      {
        if (DispDopInfo==3 || DispDopInfo==4)
        {
          if (!(BeepStateProcess&B00000010) && DispDopInfo==3) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 2 разряде
          if (!(BeepStateProcess&B00000100) && DispDopInfo==4) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 3 разряде
        }
        else
          my_beep(BEEP_LONG); // Сначала пищим, предупреждая.
      }
      else
        my_beep(BEEP_LONG); // Сначала пищим, предупреждая.


      if(DispDopInfo==1) sprintf(lcd_buffer,"Smena TARA!(%3i)",(IspReg==117 || IspReg==118) ? COUNT_ALARM_UROVEN_FR-CountAlarmUroven :COUNT_ALARM_UROVEN-CountAlarmUroven); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==2) sprintf(lcd_buffer,"VODA! (%3i)",COUNT_ALARM_VODA-CountAlarmVoda); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==3) sprintf(lcd_buffer,"Low Power! %3iV",MaxVoltsOut); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==6) sprintf(lcd_buffer,"HIGH Power! %3iV",MaxVoltsOut); //Выводим на экран инфомацию о необходимости замены тары.
      if(DispDopInfo==4) sprintf(lcd_buffer,"Err temp! ds=%2i",(int) NumErrDs18 ); //Выводим на экран инфомацию о ошибке чтения датчика.
      if(DispDopInfo==5) sprintf(lcd_buffer,"!PRESS=%3i/%3i",U_MPX5010,AlarmMPX5010); //Выводим на экран инфомацию о ошибке чтения датчика.

      #if USE_GSM_WIFI==1
            // Активизируем разовую отправку состояния на сервер
            if (FlToGSM>1 && flGPRSState!=20  && flGPRSState!=164 && (timeGPRS==0 || flNeedCall==1) )
            {
              if (flNeedCall==1) 
              { 
                flGPRSState=40; // Активируем звонок если в этом есть необходимость
              }
              else  
              {   // Если в данный момент не производится дозвон, тогда активируем GPRS сессию. 
                if (flNeedCall!=2) flGPRSState=2;
              }
              // Активируем длительную сессию GPRS
              flNeedRefrServer=0;
              timeGPRS=250;
            }
      #endif
    }

    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;
  case 100:
    sprintf(lcd_buffer,"UstParam",FlState); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 101:
    sprintf(lcd_buffer,"IsR = Displaying"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 102:
    sprintf(lcd_buffer,"IsR = Termostat"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 103:
    sprintf(lcd_buffer,"IsR = Reg Power"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 104:
    sprintf(lcd_buffer,"IsR = 1 ND otbor"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 105:
    sprintf(lcd_buffer,"IsR = otbor GLV"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 106:
    sprintf(lcd_buffer,"IsR = 2 DR otbor"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 107:
    sprintf(lcd_buffer,"IsR = 3 DR otbor"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 108:
    sprintf(lcd_buffer,"IsR = Zator"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Zerno"); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 109:
    sprintf(lcd_buffer,"IsR = Rectif"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 110:// Дистилляция с дефлегматором
    sprintf(lcd_buffer,"IsR = Dist Defl"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 111:// НДРФ
    sprintf(lcd_buffer,"IsR = NDRF"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 112:// НБК
    sprintf(lcd_buffer,"IsR = NBK"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 113:// солодо-мучной затор (без варки
    sprintf(lcd_buffer,"IsR = Zator"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Solod - Muka",PowerRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 114:// Охлаждение затора
    sprintf(lcd_buffer,"IsR = HLD Zator"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"by Chiller&Mixer",PowerRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 115:// Таймер
    sprintf(lcd_buffer,"IsR = Timer"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"ust Power"); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 116:// Варка пива
    sprintf(lcd_buffer,"IsR = Brewing"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Beer"); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 117:// Фракционная дистилляция
    sprintf(lcd_buffer,"IsR = Distill"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Fractional"); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 118:// Фракционная ректификация
    sprintf(lcd_buffer,"IsR = Rectif"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Fractional"); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 130:
    sprintf(lcd_buffer,"IsR = External"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Control"); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 129:
    sprintf(lcd_buffer,"IsR = Test"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Device (%i)",FlState); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 200:
    sprintf(lcd_buffer,"Max_t_Tst=%5i",TempTerm); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 201:
    sprintf(lcd_buffer,"Power TEN=%5u",Power); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 202:
    sprintf(lcd_buffer,"Power Reg=%5u",UstPowerReg); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 203:
    sprintf(lcd_buffer,"ParamUSART=%u",FlToUSART); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 204:
    sprintf(lcd_buffer,"ParamGSM=%u",FlToGSM); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    if(FlToGSM==1 || FlToGSM==0) sprintf(lcd_buffer,"GSM (SMS)"); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==2) sprintf(lcd_buffer,"GPRS Megafon"); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==3) sprintf(lcd_buffer,"GPRS BeeLine"); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==4) sprintf(lcd_buffer,"GPRS MTS"); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==5) sprintf(lcd_buffer,"GPRS Rostelecom"); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==6) sprintf(lcd_buffer,"GPRS Tele 2"); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM>=7) sprintf(lcd_buffer,"GPRS Reserv %i", (int) FlToGSM); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==10) sprintf(lcd_buffer,"Wi-Fi"); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==11) sprintf(lcd_buffer,"Android ext"); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM==12) sprintf(lcd_buffer,"Android int"); //запись в буфер текста и значений температуры в подготовленном
    if(FlToGSM>12) sprintf(lcd_buffer,"Err! 0..11 (%i)",(int) FlToGSM); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 205:
    sprintf(lcd_buffer,"dtTermostat=%3i",Delta); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 206:
    sprintf(lcd_buffer,"Temp 1 Nedrobn"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Distill=%3i",Temp1P); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 207:
    sprintf(lcd_buffer,"Temp 2 Drobn"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Distill=%3i",Temp2P); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 208:
    sprintf(lcd_buffer,"Temp 3 Drobn"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Distill=%3i",Temp3P); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 209:
    sprintf(lcd_buffer,"Temp Razgon Rect"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"(+Kub,-Kol)=%3i",tEndRectRazgon); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 210:
    sprintf(lcd_buffer,"Power"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Rectif=%3i",PowerRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 211:
    sprintf(lcd_buffer,"Vvod Popravok"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"ds18b20 "); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 212:
    sprintf(lcd_buffer,"Temp Okon Otbor"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Glv Rectif=%3i",tEndRectOtbGlv ); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 213:
    sprintf(lcd_buffer,"CHIM Otbor GLV"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Rectif=%5u",timeChimRectOtbGlv); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 214:
    sprintf(lcd_buffer,"%% CHIM Otbor GLV"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Rectif=%3i",(int) ProcChimOtbGlv); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 215:
    sprintf(lcd_buffer,"CHIM Otbor SR"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Rectif=%5u",timeChimRectOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 216:
    sprintf(lcd_buffer,"Delta Otbor SR"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Rectif=%3u",tDeltaRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 217:
    sprintf(lcd_buffer,"Temp Okon Otbor"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"SR Rectif=%3i",tEndRectOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 218:
    sprintf(lcd_buffer,"Temp Okon"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Rectif=%3i",tEndRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 250:
    sprintf(lcd_buffer,"min %% CHIM"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer," Otbor SR=%2i",minProcChimOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 251:
    sprintf(lcd_buffer,"Edit Temp Stab"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Rectif=%3i",tStabSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 252:
    sprintf(lcd_buffer,"Beg %% CHIM"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer," Otbor SR=%2i",begProcChimOtbSR); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 253:
    sprintf(lcd_buffer,"Popr MPX=%4i",P_MPX5010); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"%4i/%4i",U_MPX5010,U_MPX5010+P_MPX5010); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 219:
    sprintf(lcd_buffer,"Power GLV simple"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Distill=%4i",PowerGlvDistil); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 220:
    sprintf(lcd_buffer,"Power simple"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Distill=%4i",PowerDistil); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 221:
    sprintf(lcd_buffer,"Temp Begin Dist"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"(+Def -Kub)=%3i",TempDeflBegDistil); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 222:
    sprintf(lcd_buffer,"Temp Distill"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"With Defl=%3i",TempDefl); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 223:
    sprintf(lcd_buffer,"Delta Distill"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"With Defl=%3i",DeltaDefl); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 224:
    sprintf(lcd_buffer,"Temp Kub Okon"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"DistWithDefl=%3i",tEndDistDefl); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 225:
    sprintf(lcd_buffer,"BeepEndProc=%1u",BeepEndProcess); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 226:
    sprintf(lcd_buffer,"BeepStateProc=%1u",BeepStateProcess); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 227:
    sprintf(lcd_buffer,"BeepKeyPress=%1u",BeepKeyPress); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 228:
    sprintf(lcd_buffer,"Power Razvar"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Zerno=%4i",PowerRazvZerno); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 229:
    sprintf(lcd_buffer,"Power Varka"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Zerno=%4i",PowerVarkaZerno); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 230:
    sprintf(lcd_buffer,"Period Refresh");
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Server(sec)=%3u",(unsigned int) PeriodRefrServer); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer);
    break;
  case 231:
    sprintf(lcd_buffer,"U Peregrev=%3uV",(unsigned int) NaprPeregrev); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 232:
    sprintf(lcd_buffer,"Urv Barda=%4i",UrovenBarda); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    sprintf(lcd_buffer,"Barda(%4u)",U_GLV); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer);
    break;
  case 233:
    sprintf(lcd_buffer,"Provod SR=%4i",UrovenProvodimostSR); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 234:
    sprintf(lcd_buffer,"Time Stab (+/-)"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Kolonna=%5isec",TimeStabKolonna); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 235:
    sprintf(lcd_buffer,"Edit T & CHIM"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Count CHIM=%3i",(int) CntCHIM); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 236:
    sprintf(lcd_buffer,"Auto - CHIM=%3i",(int)DecrementCHIM); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 237:
    sprintf(lcd_buffer,"Auto + CHIM=%3i",(int)IncrementCHIM); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer);
    break;
  case 238:
    sprintf(lcd_buffer,"Time Auto +"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"CHIM=%5isec",TimeAutoIncCHIM); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 239:
    sprintf(lcd_buffer,"Time reStab(+/-)"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Kolonna=%5isec",TimeRestabKolonna); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 240:
    sprintf(lcd_buffer,"Beer Pause"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Count =%3i",(int) CntPause); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 241:
    sprintf(lcd_buffer,"Power correct"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"ASC712 =%3i",(int) CorrectASC712); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 242:
    sprintf(lcd_buffer,"Server adr="); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"%3u.%3u.%3u.%3u",(unsigned int)ip[0],(unsigned int)ip[1],(unsigned int)ip[2],(unsigned int)ip[3]); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 243:
    sprintf(lcd_buffer,"Server port="); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"%u",ipPort); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 244:
    sprintf(lcd_buffer,"ID Device="); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"%s",idDevice); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 245:
    sprintf(lcd_buffer,"My Phone="); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"%s",my_phone); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 246:
    sprintf(lcd_buffer,"Alarm Pressure"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"MPX5010=%i",AlarmMPX5010); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 247:
    sprintf(lcd_buffer,"Use Avtonom"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"HLD=%i",FlAvtonom); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 248:
    sprintf(lcd_buffer,"Time Open"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"BRD=%i",(int)timeOpenBRD); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 249:
    sprintf(lcd_buffer,"PID Paramters"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"%4i %4i %4i",(int)PIDTemp[0],(int)PIDTemp[1],(int)PIDTemp[2]); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 254:
    sprintf(lcd_buffer,"Power NBK=%4i",PowerNBK); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 255:
    sprintf(lcd_buffer,"Wi-Fi AP="); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"%s",WiFiAP); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 256:
    sprintf(lcd_buffer,"Wi-Fi Password="); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"%s",WiFiPass); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 257:
    sprintf(lcd_buffer,"Fraction Dist"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Count =%3i",(int) CountFractionDist); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 258:
    sprintf(lcd_buffer,"Fraction Rectif"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Count =%3i",(int) CountFractionRect); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 259:
    sprintf(lcd_buffer,"Temp Zasyp"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Zator=%3i",(int) TempZSP*10); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 260:
    sprintf(lcd_buffer,"Temp Osahariv"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Zator=%3i",(int) TempZSPSld*10); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 261:
    sprintf(lcd_buffer,"Temp Brogenia"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Zator=%3i",(int) TempHLDZatorBrog1*10); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 262:
    sprintf(lcd_buffer,"PhasePW %5i=",Power); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"%4i+%4i+%4i",PowerPhase[0],PowerPhase[1],PowerPhase[2]); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 263:
    sprintf(lcd_buffer,"Phase%% %3i=",(int)KtPhase[0]+KtPhase[1]+KtPhase[2]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"%3i + %3i + %3i",(int)KtPhase[0],(int)KtPhase[1],(int)KtPhase[2]);
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;   
  case 264:
    sprintf(lcd_buffer,"min Pressure"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"NBK=%3i+%3i=%3i",(int) minPressNBK*5,(int) deltaPressNBK,(int) minPressNBK*5+(int) deltaPressNBK); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;     
  case 265:
    sprintf(lcd_buffer,"delta Pressure"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"NBK=%3i+%3i=%3i",(int) minPressNBK*5,(int) deltaPressNBK,(int) minPressNBK*5+(int) deltaPressNBK); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;     
  case 266:
    sprintf(lcd_buffer,"time Pressure"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"NBK=%3i",(int) timePressNBK*5); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;     
  case 267:
    sprintf(lcd_buffer,"Upravl Nasos"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"NBK=%3i",(int)UprNasosNBK); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;     
  case 268:
    sprintf(lcd_buffer,"%% otbor Tsarga"); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Paster(+/-)=%3i",(int)ProcChimOtbCP); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;     
  case 300:
    sprintf(lcd_buffer,"Temp%1i=%3u",nPopr,temps[nPopr]); //запись в буфер текста и значений температуры в подготовленном
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"Popr=%3i T=%3u",ds1820_popr[nPopr], (temps[nPopr]+ds1820_popr[nPopr])); //запись в буфер текста и значений температуры в подготовленном
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 301:
    sprintf(lcd_buffer,"TempK(%1i)=%4i",(int) nPopr, tempK[nPopr]); //запись в буфер текста и значений температуры в подготовленном
    if (flPopr==0) 
    {  
      sprintf(lcd_buffer,"%s %c",lcd_buffer,'*');
    }

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf(lcd_buffer,"CHIM(%1i)=%3i", (int) nPopr, (int) CHIM[nPopr]); //запись в буфер текста и значений температуры в подготовленном
    if (flPopr==1) 
    {  
      sprintf(lcd_buffer,"%s %c",lcd_buffer,'*');
    }

    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 302:
    // Первое значение это время работы насоса
    if (nPopr==0) 
      sprintf(lcd_buffer,"Work Pump =%2im",(int) tempP[nPopr]); //запись в буфер текста и значений температуры в подготовленном 
    else
      sprintf(lcd_buffer,"TemP(%1i)=%3i.0",(int) nPopr, (int) tempP[nPopr]); //запись в буфер текста и значений температуры в подготовленном

    if (flPopr==0) 
    {  
      sprintf(lcd_buffer,"%s %c",lcd_buffer,'*');
    }

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    if (nPopr==0) 
      sprintf(lcd_buffer,"Pause Pump=%2im",(int) timeP[nPopr]); //запись в буфер текста и значений температуры в подготовленном 
    else
      sprintf(lcd_buffer,"TimP(%1i)=%3i m", (int) nPopr, (int) timeP[nPopr]); //запись в буфер текста и значений температуры в подготовленном

    if (flPopr==1) 
    {  
      sprintf(lcd_buffer,"%s %c",lcd_buffer,'*');
    }

    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 303:
    sprintf(lcd_buffer,"%3u.%3u.%3u.%3u",(unsigned int)ip[0],(unsigned int)ip[1],(unsigned int)ip[2],(unsigned int)ip[3]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=-1;
    while (j<nPopr*4)
    {
      j++;
      lcd_buffer[j]=' ';
    }
    lcd_buffer[j+1]='*';
    lcd_buffer[j+2]=0;

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;
  case 304:
    sprintf(lcd_buffer,"%s (%3u)",idDevice,(unsigned int)idDevice[nPopr] );
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<nPopr)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;

  case 305:
    sprintf(lcd_buffer,"%s/%3u)",my_phone,(unsigned int)my_phone[nPopr]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<nPopr)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;
  case 309:
    sprintf(lcd_buffer,"%4i %4i %4i",(int)PIDTemp[0],(int)PIDTemp[1],(int)PIDTemp[2]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    if (nPopr==0) sprintf(lcd_buffer,"   P");
    if (nPopr==1) sprintf(lcd_buffer,"        I");
    if (nPopr==2) sprintf(lcd_buffer,"             D");
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;

  case 310:
    sprintf(lcd_buffer,"%s /%3u",WiFiAP,(unsigned int)WiFiAP[nPopr] );
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<nPopr)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;
  case 311:
    sprintf(lcd_buffer,"%s /%3u",WiFiPass,(unsigned int)WiFiPass[nPopr] );
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    j=0;
    while (j<nPopr)
    {
      lcd_buffer[j]=' ';
      j++;
    }
    lcd_buffer[j]='*';
    lcd_buffer[j+1]=0;

    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

    break;
  case 312:
    // последнее значение это тест фракционника
    if (nPopr==MAX_CNT_FRACTION_DIST)
    { 
      sprintf(lcd_buffer,"Fraction Dist"); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"Test =%3i",(int) TekFraction+1); //запись в буфер текста и значений температуры в подготовленном
    }
    else
    {
      if (TempFractionDist[nPopr]>=0)
        sprintf(lcd_buffer,"tFrDst(%1i)=%4i",(int) nPopr+1, (int) TempFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном
      else
        sprintf(lcd_buffer,"timFD(%1i)=%5im",(int) nPopr+1, (int) -TempFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном        

      if (flPopr==0) 
      {  
        sprintf(lcd_buffer,"%s%c",lcd_buffer,'*');
      }

      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

      if (flPopr==1)  sprintf(lcd_buffer,"Angl=%3i*,%4iW",(int) AngleFractionDist[nPopr] , PowerFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном
      else  sprintf(lcd_buffer,"Angl=%3i ,%4iW",(int) AngleFractionDist[nPopr] , PowerFractionDist[nPopr]); //запись в буфер текста и значений температуры в подготовленном 

      if (flPopr==2)  sprintf(lcd_buffer,"%s%c",lcd_buffer,'*');
    }
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 313:
    // последнее значение это тест фракционника
    if (nPopr==MAX_CNT_FRACTION_RECT)
    { 
      sprintf(lcd_buffer,"Fraction Rect"); //запись в буфер текста и значений температуры в подготовленном
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"Test =%3i",(int) TekFraction+1); //запись в буфер текста и значений температуры в подготовленном
    }
    else
    {
      if (TempFractionRect[nPopr]>=0)
        sprintf(lcd_buffer,"tFrRect(%1i)=%4i",(int) nPopr+1, (int) TempFractionRect[nPopr]); //запись в буфер текста и значений температуры в подготовленном
      else
        sprintf(lcd_buffer,"timFR(%1i)=%5im",(int) nPopr+1,(int) -TempFractionRect[nPopr]); //запись в буфер текста и значений температуры в подготовленном        

      if (flPopr==0) 
      {  
        sprintf(lcd_buffer,"%s%c",lcd_buffer,'*');
      }

      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf(lcd_buffer,"Angle=%3i",(int) AngleFractionRect[nPopr]); //запись в буфер текста и значений температуры в подготовленном 

      if (flPopr==1)  sprintf(lcd_buffer,"%s%c",lcd_buffer,'*');
    }
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;    
  case 314:
    sprintf(lcd_buffer,"%4i %4i %4i",(int)PowerPhase[0],(int)PowerPhase[1],(int)PowerPhase[2]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    if (nPopr==0) sprintf(lcd_buffer," PH1");
    if (nPopr==1) sprintf(lcd_buffer,"      PH2");
    if (nPopr==2) sprintf(lcd_buffer,"           PH3");
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  case 315:
    sprintf(lcd_buffer,"%3i %3i %3i=%3i",(int)KtPhase[0],(int)KtPhase[1],(int)KtPhase[2],(int)KtPhase[0]+KtPhase[1]+KtPhase[2]);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    lcd.setCursor(0, 1);
    if (nPopr==0) sprintf(lcd_buffer,"PH1");
    if (nPopr==1) sprintf(lcd_buffer,"    PH2");
    if (nPopr==2) sprintf(lcd_buffer,"        PH3");
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    break;
  default:
    break;
  }

  //    
  //  lcd.setCursor(0, 0);
  //  my_lcdprint(Seconds);
  //  lcd.setCursor(5, 0);
  //  my_lcdprint(MaxVoltsOut);
  //  lcd.setCursor(9, 0);
  //  my_lcdprint((long)MaxVoltsOut*707/1000);
  //  lcd.setCursor(0, 1);
  //  my_lcdprint(index_input);
  //  lcd.setCursor(5, 1);
  //  my_lcdprint(TimeOpenTriac);
  //  NeedDisplaying=false;
  //  lcd.setCursor(10, 1);
  //  my_lcdprint(TicZero);
  // предупреждения теперь выводим на всех страницах.

  if (flNumStrPrint<2) 
  {
    lcd_buffer[0]=0;
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
  }
  NeedDisplaying=false;

}
